/* ------- Login Functions ------------------------------------------------- */
function show_login()
{
	var password = $('password');
	
	password.value = '';
	clear_message('message_panel');
	Element.hide('default_controls');
	Element.hide('main_controls');
	Element.hide('add_controls');
	Element.show('login_controls');
	Field.focus(password);
}

function login()
{
	var password = $('password');
	
	clear_message('message_panel');
	
	if (password.value == '')
	{
		alert('Password is a required field.');
		return;
	}
	
	password.disabled = true;
	
	var opt = {
		method: 'post',
		postBody: 'password=' + password.value,
		onSuccess: function(t)
		{
			Element.hide('default_controls');
			Element.hide('login_controls');
			Element.hide('add_controls');
			Element.show('main_controls');
			$('password').disabled = false;
		},
		onFailure: function(t)
		{
			show_failure(t.responseText, 'message_panel');
			$('password').disabled = false;
			Field.focus('password');
		}
	}
	
	new Ajax.Request('ajax/ajax_login.php', opt);
}

function cancel_login()
{
	clear_message('message_panel');
	Element.hide('login_controls');
	Element.hide('main_controls');
	Element.hide('add_controls');
	Element.show('default_controls');
}

function logout()
{
	Element.show('main_wait');
	clear_message('message_panel');
	var opt = {
		method: 'post',
		onSuccess: function(t)
		{
			Element.hide('login_controls');
			Element.hide('main_controls');
			Element.hide('add_controls');
			Element.show('default_controls');
			Element.hide('main_wait');
		},
		onFailure: function(t)
		{
			Element.hide('main_wait');
			show_failure('Error logging out: ' + t.responseText, "message_panel");
		}
	}
	
	new Ajax.Request('ajax/ajax_logout.php', opt);
}

function login_keypress(evt)
{
	if (evt.keyCode == Event.KEY_RETURN) 
	{
		login();
		Event.stop(evt);
	}
	if (evt.keyCode == Event.KEY_ESC) 
	{
		cancel_login();
		Event.stop();
	}
}

/* ------- Add Functions ---------------------------------------------------- */
function show_add()
{
	$('new_page').value = '';
	clear_message('message_panel');
	
	Element.hide('add_wait');
	Element.hide('default_controls');
	Element.hide('login_controls');
	Element.hide('main_controls');
	Element.show('add_controls');
	
	Field.focus('new_page');
}

function cancel_add()
{
	clear_message('message_panel');
	Element.hide('add_wait');
	Element.hide('default_controls');
	Element.hide('login_controls');
	Element.hide('add_controls');
	Element.show('main_controls');
}

function go_to()
{
	var new_page = $('new_page').value;
	clear_message('message_panel');
	
	if (new_page == '')
	{
		cancel_add();
		return;
	}
	
	Element.show('add_wait');
	location.href = 'index.php?id=' + escape(new_page) + '&edit=1';
}


function new_page_keypress(evt)
{
	if (evt.keyCode == Event.KEY_RETURN) 
	{
		go_to();
		Event.stop(evt);
	}
	if (evt.keyCode == Event.KEY_ESC) 
	{
		cancel_add();
		Event.stop(evt);
	}
}

window.onload = function()
{
	$('show_login').onclick = function() { show_login(); return false; };
	$('login').onclick = function() { login(); return false; };
	$('cancel_login').onclick = function() { cancel_login(); return false; };
	$('logout').onclick = function() { logout(); return false; };
	$('password').onkeypress = login_keypress.bindAsEventListener(this);
	
	$('add_page').onclick = function() { show_add(); return false; };
	$('new_page').onkeypress = new_page_keypress.bindAsEventListener(this);
	$('go_to').onclick = function() { go_to(); return false; };
	$('cancel_add').onclick = function() { cancel_add(); return false };
}
