var original_raw = "";
var original_category = "";

/* ------- Edit Functions -------------------------------------------------- */
function edit_page()
{
	original_raw = $('raw_content').value;
	original_category = $('category').value;

	clear_message('message_panel');
	Element.hide('content_panel');
	Element.hide('locked_panel');
	Element.show('edit_panel');
	
	Element.hide('default_controls');
	Element.hide('main_controls');
	Element.hide('login_controls');
	Element.hide('add_controls');
	Element.show('edit_controls');
	
	Field.focus('raw_content');
}

function cancel_edit()
{	
	clear_message('message_panel');
	Element.hide('locked_panel');
	Element.hide('edit_panel');
	Element.show('content_panel');
	
	Element.hide('default_controls');
	Element.hide('login_controls');
	Element.hide('edit_controls');
	Element.hide('add_controls');
	Element.show('main_controls');
	
	$('raw_content').value = original_raw;
	$('category').value = original_category;
}

function save_page()
{
	var raw_content = $('raw_content');
	var category = $('category');
	var editor = $('editor');
	
	clear_message('message_panel');
	
	if (category.value == '')
	{
		show_failure("Category is a required field", "message_panel");
		return;
	}
	
	if (raw_content.value == '')
	{
		show_failure("Raw content is a required field", "message_panel");
		return;
	}
	
	if (editor.value == '')
	{
		show_failure("Editor is a required field", "message_panel");
		return;
	}
	
	if (raw_content.value == original_raw && category.value == original_category) 
	{
		cancel_edit();
		show_failure("No information was changed, so no save took place", "message_panel");
		
		return;
	}

	raw_content.disabled = true;
	category.disabled = true;
	editor.disabled = true;
	$('edit_page').onclick = function() { return false; };
	$('save_page').onclick = function() { return false; };
	$('cancel_edit').onclick = function() { return false; };
	Element.show('edit_wait');
	
	var post_body = "id=" + my_escape($('id').value);
	post_body += "&category=" + my_escape(category.value);
	post_body += "&raw_content=" + my_escape(raw_content.value);
	post_body += "&editor=" + my_escape($('editor').value);
	
	var opt = {
		method: 'post',
		postBody: post_body,
		onSuccess: function(t)
		{
			$('content_panel').innerHTML = t.responseText + "<hr />";
			
			Element.hide('locked_panel');
			Element.hide('edit_panel');
			Element.show('content_panel');
			
			Element.hide('default_controls');
			Element.hide('login_controls');
			Element.hide('edit_controls');
			Element.hide('add_controls');
			Element.show('main_controls');
	
			Element.hide('edit_wait');
			raw_content.disabled = false;
			category.disabled = false;
			editor.disabled = false;
			$('edit_page').onclick = function() { edit_page(); return false; };
			$('save_page').onclick = function() { save_page(); return false; };
			$('cancel_edit').onclick = function() { cancel_edit(); return false; };
		},
		onFailure: function(t)
		{
			show_failure("Error while saving page: " + t.responseText, "message_panel");
		}
	}
	
	new Ajax.Request('ajax/ajax_commit.php', opt);
}

function raw_content_keypress(evt)
{
	// In IE, if CTRL is held down, RETURN is 10, not 13
	if (evt.ctrlKey && evt.keyCode == Event.KEY_RETURN) 
	{
		save_page();
		Event.stop(evt);
	}
	else if (evt.ctrlKey && evt.keyCode == 10) 
	{
		save_page();
		Event.stop(evt);
	}
	else if (evt.keyCode == Event.KEY_ESC) 
	{
		cancel_edit();
		Event.stop(evt);
	}
}

/* ------- Login Functions ------------------------------------------------- */
function show_login()
{
	var password = $('password');
	
	password.value = '';
	clear_message('message_panel');
	Element.hide('default_controls');
	Element.hide('edit_controls');
	Element.hide('main_controls');
	Element.hide('add_controls');
	Element.show('login_controls');
	Field.focus(password);
}

function login()
{
	var password = $('password');
	
	clear_message('message_panel');
	
	if (password.value == '')
	{
		show_failure('Password is a required field.', 'message_panel');
		return;
	}
	
	Element.show('login_wait');
	password.disabled = true;
	
	var opt = {
		method: 'post',
		postBody: 'password=' + password.value,
		onSuccess: function(t)
		{
			Element.hide('default_controls');
			Element.hide('edit_controls');
			Element.hide('login_controls');
			Element.hide('add_controls');
			Element.show('main_controls');
			Element.hide('login_wait');
			$('password').disabled = false;
		},
		onFailure: function(t)
		{
			show_failure(t.responseText, 'message_panel');
			$('password').disabled = false;
			$('password').value = '';
			Field.focus('password');
			Element.hide('login_wait');
		}
	}
	
	new Ajax.Request('ajax/ajax_login.php', opt);
}

function cancel_login()
{
	clear_message('message_panel');
	Element.hide('edit_controls');
	Element.hide('login_controls');
	Element.hide('main_controls');
	Element.hide('add_controls');
	Element.show('default_controls');
}

function logout()
{
	Element.show('main_wait');
	clear_message('message_panel');
	var opt = {
		method: 'post',
		onSuccess: function(t)
		{
			Element.hide('edit_controls');
			Element.hide('login_controls');
			Element.hide('main_controls');
			Element.hide('add_controls');
			Element.show('default_controls');
			Element.hide('main_wait');
		},
		onFailure: function(t)
		{
			Element.hide('main_wait');
			show_failure('Error logging out: ' + t.responseText, "message_panel");
		}
	}
	
	new Ajax.Request('ajax/ajax_logout.php', opt);
}

function login_keypress(evt)
{
	if (evt.keyCode == Event.KEY_RETURN) 
	{
		login();
		Event.stop(evt);
	}
	if (evt.keyCode == Event.KEY_ESC) 
	{
		cancel_login();
		Event.stop(evt);
	}
}

/* ------- Delete Functions ------------------------------------------------- */
function delete_page()
{
	var id = $('id');
	clear_message('message_panel');
	if (confirm("Are you sure you want to delete " + id.value + "?"))
	{
		$('delete_page').onclick = function() { return false; };
		Element.show('main_wait');
		var opt = {
			method: 'post',
			postBody: 'id=' + my_escape(id.value),
			onSuccess: function(t)
			{
				$('content_panel').innerHTML = t.responseText + "<hr />";
			
				Element.hide('locked_panel');
				Element.hide('edit_panel');
				Element.show('content_panel');
				
				Element.hide('default_controls');
				Element.hide('login_controls');
				Element.hide('edit_controls');
				Element.hide('add_controls');
				Element.show('main_controls');
	
				Element.hide('main_wait');
				$('delete_page').onclick = function() { delete_page(); return false; };
				
			},
			onFailure: function(t)
			{
				Element.hide('main_wait');
				show_failure("Couldn't delete page: " + t.responseText, "message_panel");
			}
		}
		
		new Ajax.Request('ajax/ajax_delete.php', opt);
	}
}

/* ------- Add Functions ---------------------------------------------------- */
function show_add()
{
	$('new_page').value = '';
	clear_message('message_panel');
	
	Element.hide('add_wait');
	Element.hide('default_controls');
	Element.hide('login_controls');
	Element.hide('edit_controls');
	Element.hide('main_controls');
	Element.show('add_controls');
	
	Field.focus('new_page');
}

function cancel_add()
{
	clear_message('message_panel');
	Element.hide('add_wait');
	Element.hide('default_controls');
	Element.hide('login_controls');
	Element.hide('edit_controls');
	Element.hide('add_controls');
	Element.show('main_controls');
}

function go_to()
{
	var new_page = $('new_page').value;
	clear_message('message_panel');
	
	if (new_page == '')
	{
		cancel_add();
		return;
	}
	
	Element.show('add_wait');
	location.href = 'index.php?id=' + my_escape(new_page) + '&edit=1';
}

function new_page_keypress(evt)
{
	if (evt.keyCode == Event.KEY_RETURN) 
	{
		go_to();
		Event.stop(evt);
	}
	if (evt.keyCode == Event.KEY_ESC) 
	{
		cancel_add();
		Event.stop(evt);
	}
}

function my_escape(s)
{
	return escape(s).replace(/\+/g,'%2B');
}

window.onload = function()
{
	$('show_login').onclick = function() { show_login(); return false; };
	$('login').onclick = function() { login(); return false; };
	$('cancel_login').onclick = function() { cancel_login(); return false; };
	$('logout').onclick = function() { logout(); return false; };
	$('password').onkeypress = login_keypress.bindAsEventListener(this);
	
	$('edit_page').onclick = function() { edit_page(); return false; };
	$('save_page').onclick = function() { save_page(); return false; };
	$('cancel_edit').onclick = function() { cancel_edit(); return false; };
	$('raw_content').onkeypress = raw_content_keypress.bindAsEventListener(this);
	$('editor').onkeypress = raw_content_keypress.bindAsEventListener(this);
	
	$('delete_page').onclick = function() { delete_page(); return false; };
	
	$('add_page').onclick = function() { show_add(); return false; };
	$('new_page').onkeypress = new_page_keypress.bindAsEventListener(this);
	$('go_to').onclick = function() { go_to(); return false; };
	$('cancel_add').onclick = function() { cancel_add(); return false };
	
	var opt = {
		method: 'post',
		onFailure: function(t)
		{
			show_failure("Couldn't get categories: " + t.responseText, "message_panel");
		}
	}
	
	new Ajax.Autocompleter('category', 'category_autocomplete', 'ajax/ajax_autocomplete.php', opt);
}
